var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
(function (factory) {
    if (typeof module === "object" && typeof module.exports === "object") {
        var v = factory(require, exports);
        if (v !== undefined) module.exports = v;
    }
    else if (typeof define === "function" && define.amd) {
        define(["require", "exports", "../../core/Bind", "../../core/BindableProperty", "../../core/XNode", "../styles/AtomNotificationStyle", "./AtomControl"], factory);
    }
})(function (require, exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    var Bind_1 = require("../../core/Bind");
    var BindableProperty_1 = require("../../core/BindableProperty");
    var XNode_1 = require("../../core/XNode");
    var AtomNotificationStyle_1 = require("../styles/AtomNotificationStyle");
    var AtomControl_1 = require("./AtomControl");
    var AtomNotification = /** @class */ (function (_super) {
        __extends(AtomNotification, _super);
        function AtomNotification() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this.timeout = 5000;
            _this.timeoutKey = null;
            return _this;
        }
        AtomNotification.prototype.onPropertyChanged = function (name) {
            switch (name) {
                case "timeout":
                    this.setupTimeout();
                    break;
            }
        };
        AtomNotification.prototype.create = function () {
            var _this = this;
            this.defaultControlStyle = AtomNotificationStyle_1.default;
            this.render(XNode_1.default.create("div", { formattedText: Bind_1.default.oneWay(function () { return _this.viewModel.message; }), timeout: Bind_1.default.oneWay(function () { return _this.viewModel.timeout || 5000; }), styleClass: Bind_1.default.oneWay(function () {
                    var _a;
                    return (_a = {},
                        _a[_this.controlStyle.name] = 1,
                        _a.error = _this.viewModel.type && /error/i.test(_this.viewModel.type),
                        _a.warning = _this.viewModel.type && /warn/i.test(_this.viewModel.type),
                        _a);
                }) }));
        };
        AtomNotification.prototype.setupTimeout = function () {
            var _this = this;
            if (this.timeoutKey) {
                clearTimeout(this.timeoutKey);
            }
            this.timeoutKey = setTimeout(function () {
                if (_this.element) {
                    _this.app.broadcast("atom-window-close:" + _this.id, "");
                }
            }, this.timeout);
        };
        __decorate([
            BindableProperty_1.BindableProperty,
            __metadata("design:type", Number)
        ], AtomNotification.prototype, "timeout", void 0);
        return AtomNotification;
    }(AtomControl_1.AtomControl));
    exports.default = AtomNotification;
});
//# sourceMappingURL=AtomNotification.js.map